'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 15. Different functions for different data types will automatically be 
'generated provided you define a template function.
'Tired of defining the same function five times? One definition for *int* type parameters,
'one definition for *double* type parameters, one definition for *float* type parameters...
'Didn't you forget one type? What if a new data type is used? No problem: the C++ compiler
'can automatically generate every version of the function that is necessary! 
'Just tell it how the function looks like by declaring a *template* function 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Template <class ttype>
	Function minimum (a As ttype, b As ttype) As ttype
		Raw As ttype r
	
		r = a
		If b < a Then
			r = b
		End If
	
		Function = r
	End Function
End Template
'==============================================================================
Function main()
	
	Raw As int i1, i2, i3
	i1 = 34
	i2 = 6
	i3 = minimum (i1, i2)
	cout << "Most little: " << i3 << endl

	Raw As  double d1, d2, d3
	d1 = 7.9
	d2 = 32.1
	d3 = minimum (d1, d2)
	cout << "Most little: " << d3 << endl	
	cout << "Most little: " << minimum (d3, 3.5) << endl
	
	Pause
	'Result
	'    Most little: 6
	'    Most little: 7.9
	'    Most little: 3.5
	Function = EXIT_SUCCESS
End Function

