'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 29. Class derivation allows you to write generic methods
'Class derivation allows you to construct more complex classes built from base classes.
'There is another application of class derivation: allowing the programmer to write 
'generic functions.
'Suppose you define a base class with no variables. It makes no sense to use instances
'of that class inside your program. But then you write a function whose purpose 
'it is to sort instances of that class. That function will be able to sort any type 
'of object provided it belongs to a class derived from that base class! The only 
'condition is that inside of each derived class definition, all methods that the 
'sort function needs are correctly defined. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class octopus
	public:
 
    	IMPFUNCTION module() = 0 AS virtual double
        	                       ' = 0 implies function is not
                                   ' defined. This makes instances
                                   ' of this CLASS cannot be declared.
End Class
'============================================================================== 
Function biggest_module (a As octopus &, b  As octopus &, c  As octopus &) As double
	Raw As double r = a.module() 
	If b.module() > r Then
		r = b.module()
	End If 
	If c.module() > r Then
		r = c.module()   	
   End If 
   Function = r
End Function
'============================================================================== 
Class x_vector Using public octopus
	public:
		Raw As double x,y

		Constructor x_vector (a = 0 As double, b = 0 As double)
			x = a
			y = b
		End Constructor

		Function module() As double
			Function = sqrt (x * x + y * y)
		End Function
End Class
'============================================================================== 
Class number Using public octopus
	public:
		Raw As double n

		Constructor number (a = 0 As double)
			n = a
		End Constructor

		Function module() As double
			IF n >= 0 THEN
				 Function = n
			End If
			Function = -n
		End Function
End Class
'============================================================================== 
Function main () As int
	Raw As x_vector k (1,2), m (6,7), n (100, 0)
	Raw As number p (5),   q (-3),  r (-150)
	
	cout << biggest_module (k, m, n) << endl
	cout << biggest_module (p, q, r) << endl
	
	cout << biggest_module (p, q, n) << endl
	Pause
	Function = EXIT_SUCCESS
End Function
