'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
'Chapter 30_1. ENCAPSULATION: public, protected and private
'The *PUBLIC:* directive means the variables or the methods below can be accessed
'and used everywhere in the program. 
'If you want the variables and methods to be accessible only to methods of the class
'AND to methods of derived classes, then you must put the keyword *protected:* before them. 
'If you want variables or methods to be accessible ONLY to methods of the class, 
'then you must put the keyword *private:* before them. 
'The fact that variables or methods are declared private or protected means that
'nothing external to the class can access or use them. That's ENCAPSULATION. 
'(If you want to give a specific function the right to access those variables and methods,
'then you must include that function's prototype inside the class definition, preceded by
'the keyword *friend*.) 
'Good practice is to encapsulate all the variables of a class. This can sound strange
'if you're used to structs in C. Indeed a struct only makes sense if you can access its data...
'In C++ you have to create methods to access the data inside a class. The example 
'below uses the basic example of chapter 17, yet declares the class data to be protected. 
'=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*=*
$CPPHDR
$NOMAIN
'Translate with MinGW Win no Win Includes OR
'Translate with MinGW Win no Win Inc Unicode
'For Unicode uncomment the next line and add -municode to compile line
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER.TXT"
'$ONEXIT "TDMGPP.BAT $FILE$ -m64 con"
'$ONEXIT "NUWENGPP.BAT $FILE$ -m64 con"

'Translate with Win no Win Includes OR
'Translate with Win no Win Inc Unicode
'For Unicode uncomment
'$ONEXIT "ULEX.EXE $FILE$.CPP TCHARXLATER_VC.TXT"
$ONEXIT "VSCPP.BAT $FILE$ -m64 con" 
'==============================================================================
Class x_vector
	Protected:
		Raw As double x,y 
	Public:
'------------------------------------------------------------------------------	
		Sub set_x (n As int)
			x = n
		End Sub
'------------------------------------------------------------------------------
		Sub set_y (n As int)
			y = n
		End Sub
'------------------------------------------------------------------------------		
		Function surface () As double
			Raw As double s
			s = x * y
			If s < 0 Then 
				s = -s
			End If
			Function = s
		End Function
'------------------------------------------------------------------------------
End Class	
'==============================================================================	
Function main () As int
	Raw As x_vector a

	a.set_x (3)
	a.set_y (4)

	cout << "The surface of a: " << a.surface() << endl
	Pause
	Function = EXIT_SUCCESS
End Function
